<template>
  <div class="violations">
    <div class="container" id="overview-intro">
      <div class="row">
        <div class="col-sm mb-5">
          <div class="row catalogue_intro-section-text">
            <h1 class="col-12">{{ $t("message.catalogue_detail.violations.own_headline") }}</h1>
            <p class="col-8">{{ $t("message.catalogue_detail.violations.introduction") }}</p>
            <div class="col pag">
              <ul class="pagination pagination-sm float-right">
                <li class="page-item"
                    v-for="(n, index) in totalpages"
                    v-if="Math.abs(n - currentPage)  < 2 || n === totalpages || n === 1"
                    :key="n"
                    :class="{ 'active': index === currentPage-1, 'last': n === totalpages && Math.abs(n - currentPage)  > 3, 'first': n === 1 && Math.abs(n - currentPage) > 3 }">
                  <a href="" @click.prevent="fetchCatalogueViolations(n)" class="page-link" >{{ n }}</a>
                </li>
              </ul>
            </div>
          </div>
          <span v-if="this.loading === true">
            <div class="spinner-space">
              <div class="lds-ring" id="spinner-distributions">
                <div></div>
                <div></div>
                <div></div>
                <div></div>
              </div>
            </div>
          </span>
          <span v-else-if="this.loading === false && getCatalogueViolationsSize === 0">
            <div class="alert alert-success" role="alert">
              <strong>0</strong>
              {{ $t("message.catalogue_detail.violations.own_headline") }}
            </div>
          </span>
          <div v-else>
            <div v-for="(violation, index) in getCatalogueViolations" class="distribution-detail" :key="index">
              <div class="distribution-headline">
                <app-link :to="violation.reference">
                  <h3>{{violation.title}}</h3>
                </app-link>
              </div>
              <div>
                <table class="table table-borderless pl-1 bg-light">
                  <tr>
                    <td class="w-25 font-weight-bold">Result Path</td>
                    <td v-if="violation.resultPath">{{ violation.resultPath }}</td>
                    <td v-else></td>
                  </tr>
                  <tr>
                    <td class="w-25 font-weight-bold">Result Message</td>
                    <td v-if="violation.resultMessage">{{ violation.resultMessage }}</td>
                    <td v-else></td>
                  </tr>
                  <tr>
                    <td class="w-25 font-weight-bold">Value</td>
                    <td v-if="violation.resultValue">{{ violation.resultValue }}</td>
                    <td v-else></td>
                  </tr>
                </table>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
/* eslint-disable */
import {mapActions, mapGetters} from 'vuex'
import AppLink from './AppLink';

export default {
  name: 'CatalogueDetailViolations',
  components: {
    AppLink,
  },
  metaInfo () {
    return {
      title: `${this.$t('message.common.site_title_violations')} - ${this.title} - ${this.$t('message.common.site_title')}`
    }
  },
  data () {
    return {
      currentPage: 1,
      loading: true
    }
  },
  props: {
    id: {
      type: String,
      required: true
    },
    title: {
      type: String,
    },
  },
  mounted () {},
  computed: {
    // import store-getters
    ...mapGetters([
      'getCatalogueViolations',
      'getCatalogueViolationsSize'
    ]),
    totalpages () {
      if (this.getCatalogueViolationsSize > 20) {
        return Math.ceil(this.getCatalogueViolationsSize / 10)
      }
    }
  },
  methods: {
    // import store-actions
    ...mapActions([
      'loadCatalogueViolations'
    ]),
    fetchCatalogueViolations (n) {
      this.currentPage = n;
      this.loading = true;
      this.loadCatalogueViolations({ id: this.id, currentPage: this.currentPage })
        .then(() => {
          this.loading = false;
        });
    }
  },
  created() {
    if (this.id) {
      this.loadCatalogueViolations({ id: this.id, currentPage: this.currentPage })
        .then(() => {
          this.loading = false;
        });
    }
  }
}
</script>

<style scoped>
h1 {
  font-size: 1.75rem;
}
</style>
